package jp.takayuki.tools;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

/**
 * pX[h
 * @author Takayuki
 */
public class Password {

	/**
	 * nbV@: (nbVȂ)
	 */
	public static final String METHOD_PLAIN = "{plain}"; //$NON-NLS-1$

	/**
	 * nbV@: MD5
	 */
	public static final String METHOD_MD5 = "{md5}"; //$NON-NLS-1$

	/**
	 * nbV@
	 */
	private String method;

	/**
	 * nbV@ɂ
	 * nbVꂽpX[h
	 */
	private String password;

	/**
	 * p̃RXgN^
	 * @param plain ̃pX[hBÍ@͊܂܂ȂB
	 */
	public Password(String plain) {
		this.method = METHOD_PLAIN;
		this.password = plain;
	}

	/**
	 * ۑpX[hpRXgN^
	 */
	public Password() {
		this.method = METHOD_PLAIN;
		this.password = ""; //$NON-NLS-1$
	}

	/**
	 * ۑ`̃pX[hݒ肵܂B
	 * @param stored Í@܂ޕۑ`̃pX[hB
	 * @return ݒłꍇtrueA
	 * ݒłȂꍇfalseB
	 * falsȅꍇ͋̃pX[hݒ肳܂B
	 */
	public boolean setStoredPassword(String stored) {
		if (stored != null && stored.length() != 0) {
			if (stored.startsWith(METHOD_MD5)) {
				this.method = METHOD_MD5;
				this.password = stored.substring(METHOD_MD5.length());
			} else if (stored.startsWith(METHOD_PLAIN)) {
				this.method = METHOD_PLAIN;
				this.password = stored.substring(METHOD_PLAIN.length());
			}
			return true;
		}
		return false;
	}

	/**
	 * vpeBۑp̕擾܂B
	 * vpeBۑp̕ݒ肷ɂ̓RXgN^gp܂B
	 * ftHgMD5ɂnbVꂽ񂪖߂܂A
	 * nbVłȂꍇ͕߂܂B
	 * @return ۑp̕
	 */
	public String getStoredPassword() {
		/*
		 * ̏ꍇMD5ŃnbVɂ܂B
		 * Oꍇ͕̂܂܂ɂ܂B
		 */
		if (method.equals(METHOD_PLAIN)) {
			try {
				this.password = getMd5String(this.password);
				this.method = METHOD_MD5;
			} catch (NoSuchAlgorithmException ignore) {
				//
			}
		}
		return method + password;
	}

	/**
	 * MD5ŃnbV܂B
	 * @param plain 
	 * @return nbVl
	 * @throws NoSuchAlgorithmException
	 */
	private String getMd5String(String plain) throws NoSuchAlgorithmException {
		MessageDigest md = MessageDigest.getInstance("MD5"); //$NON-NLS-1$
		md.update(plain.getBytes());
		byte[] bytes = md.digest();
		return Tool.bytesToHexString(bytes);
	}

	/**
	 * w肳ꂽpX[hv邩ׂ܂B
	 * @param plain Ώۂ̕̕
	 * @return vꍇtrue
	 * @throws NoSuchAlgorithmException 
	 */
	public boolean equals(String plain) throws NoSuchAlgorithmException {
		if (method.equals(METHOD_PLAIN)) {
			return this.password.equals(plain);
		} else if (method.equals(METHOD_MD5)) {
			String md5 = getMd5String(plain);
			return password.equals(md5);
		}
		return false;
	}

	/**
	 * pX[h󂩂ǂ擾܂B
	 * @return ̏ꍇ,true
	 */
	public boolean isEmptyPassword() {
		if (method.equals(METHOD_PLAIN)
				&& (password == null || password.length() == 0)) {
			return true;
		}
		if (method.equals(METHOD_MD5)) {
			return password.equals("D41D8CD98F00B204E9800998ECF8427E"); //$NON-NLS-1$
		}
		return false;
	}
}
