package petaclone;

import jp.takayuki.tools.Tool;

/**
 * sɊւNXłB
 * FIXME IPAhX̃[eBeB\bhNXƃv[XNXɕ
 * @author Takayuki Shoji
 */
public class RuntimeProperties {

	/**
	 * ʏ
	 */
	public static final int PRESENCE_NORMAL = 0;

	/**
	 * s
	 */
	public static final int PRESENCE_ABSENCE = 1;

	/**
	 * s
	 */
	public static final int PRESENCE_AUTO_ABSENCE = 2;

	/**
	 * Java Web Startǂ
	 */
	private static final boolean SANDBOX;
	static {
		String name = Thread.currentThread().getThreadGroup().getName();
		SANDBOX = !name.equals("main"); //$NON-NLS-1$
	}

	/**
	 * s݃[hȂtrue
	 */
	private int presence = PRESENCE_NORMAL;

	/**
	 * s݃bZ[W
	 */
	private String absenceMessage;

	/**
	 * IȂtrue
	 */
	private boolean quit;

	/**
	 * RXgN^
	 */
	public RuntimeProperties() {
		//
	}

	/**
	 * @return OS̃OCԂ܂B
	 */
	public String getLoginName() {
		return System.getProperty("user.name"); //$NON-NLS-1$
	}

	/**
	 * @return RZ~RɃGXP[vOCԂ܂B
	 */
	public String getLoginNameEscaped() {
		String name = getLoginName();
		return Tool.escapeColon(name);
	}

	/**
	 * @return s݃[hȂtrueԂ܂B
	 */
	public synchronized boolean isAbsence() {
		return this.presence != 0;
	}

	/**
	 * v[X擾܂B
	 * @return v[X
	 */
	public synchronized int getPresence() {
		return this.presence;
	}

	/**
	 * v[Xݒ肵܂B
	 * @param presence v[X
	 */
	public synchronized void setPresence(int presence) {
		this.presence = presence;
	}

	/**
	 * s݃bZ[W擾܂B
	 * @return s݃bZ[W
	 */
	public String getAbsenceMessage() {
		return this.absenceMessage;
	}

	/**
	 * s݃bZ[Wݒ肵܂B
	 * @param message s݃bZ[W
	 */
	public void setAbsenceMessage(String message) {
		this.absenceMessage = message;
	}

	/**
	 * @return I[hȂtrue
	 */
	public boolean isQuit() {
		return quit;
	}

	/**
	 * ݂̏I[hݒ肵܂B
	 * @param quit I[hȂtrue
	 */
	public void setQuit(boolean quit) {
		this.quit = quit;
	}

	/**
	 * Java Web StartǂԂ܂B
	 * @return Java Web Start̏ꍇtrue
	 */
	public boolean isSandBox() {
		return SANDBOX;
	}

}
