package petaclone;

/**
 * UniqueMemberComparatorBw肵ĔrB
 * @author Takayuki Shoji
 */
public class UniqueMemberComparator implements TableComparator {

	/**
	 * serialVersionUID
	 */
	private static final long serialVersionUID = 1L;

	/** OɃ\[gꂽԍ */
	private int sortColumn = -1;

	/** \[g */
	private int sortDirection = 0;

	/** O[v */
	private String group;

	/**
	 * @see petaclone.TableComparator#setSortColumn(int)
	 */
	public void setSortColumn(int column) {
		this.sortColumn = column;
	}

	/**
	 * @return \[gΏۗ
	 */
	public int getSortColumn() {
		return sortColumn;
	}

	/**
	 * @return \[g
	 */
	public int getSortDirection() {
		return sortDirection;
	}

	/**
	 * @param sortDirection \[g
	 */
	public void setSortDirection(int sortDirection) {
		this.sortDirection = sortDirection;
	}

	/**
	 * @param group O[v
	 */
	public void setGroup(String group) {
		this.group = group;
	}

	/**
	 * @see java.util.Comparator#compare(Object, Object)
	 */
	public int compare(Object o1, Object o2) {
		UniqueMember um1 = (UniqueMember) o1;
		UniqueMember um2 = (UniqueMember) o2;
		if (sortColumn == 2 && group != null) {
			// O[vD悷
			boolean um1gr = um1.getGroup() == null ? false : um1.getGroup()
					.equalsIgnoreCase(group);
			boolean um2gr = um2.getGroup() == null ? false : um2.getGroup()
					.equalsIgnoreCase(group);
			if (um1gr && !um2gr) {
				return -1 * sortDirection;
			} else if (!um1gr && um2gr) {
				return 1 * sortDirection;
			}
		}
		return um1.compareBy(this.sortColumn, um2) * this.sortDirection;
	}

}
