package petaclone.logic;

import petaclone.AppPreferences;
import petaclone.EventListener;
import petaclone.Message;
import petaclone.MessageLogger;
import petaclone.MessageStorage;
import petaclone.MessengerFacade;
import petaclone.SoundPlayer;

/**
 * bZ[WMCxg
 * @author Takayuki Shoji
 */
public class NewMessageReceived implements EventListener {

	/**
	 * ݒ
	 */
	private AppPreferences pref;

	/**
	 * ۊǔ
	 */
	private MessageStorage messageStorage;

	/**
	 * bZ[Wlogger
	 */
	private MessageLogger logger;

	/**
	 * TEh
	 */
	private SoundPlayer soundPlayer;

	/**
	 * bZW[
	 */
	private MessengerFacade facade;

	/**
	 * RXgN^
	 * @param pref 
	 * @param logger 
	 * @param messageStorage 
	 * @param soundPlayer 
	 * @param facade 
	 */
	public NewMessageReceived(AppPreferences pref, MessageLogger logger,
			MessageStorage messageStorage, SoundPlayer soundPlayer,
			MessengerFacade facade) {
		this.pref = pref;
		this.messageStorage = messageStorage;
		this.logger = logger;
		this.soundPlayer = soundPlayer;
		this.facade = facade;
	}

	/**
	 * Cxg
	 */
	public void listen(String eventName, Object event) {
		Message message = (Message) event;

		// IP MessengerŐL^
		if (pref.getLogEnabled()) {
			logger.writeMessageLog(message);
		}

		// MbZ[Ẅꎞۊ
		messageStorage.add(message);

		// TEhĐ
		soundPlayer.play();

		// _E[h
		facade.autoDownload(message);

		// TODO sݎɃ[]
	}
}
