package petaclone.swt;

import jp.takayuki.swt.util.SWTUtils;
import jp.takayuki.tools.MessageMap;

import org.eclipse.swt.widgets.Shell;

import petaclone.Protocol;
import petaclone.UniqueMember;

/**
 * bZ[Wꍇ̃bZ[W_CAO\܂B
 * @author Takayuki Shoji
 */
public class OnTooLongMessage implements Runnable {
	/**
	 * bZ[W\[X
	 */
	private static final MessageMap mm = MessageMap.getMessageMap();

	/**
	 * bZ[WvgR
	 */
	private Protocol protocol;

	/**
	 * bZ[W{bNX̐eShell
	 */
	private Shell shell;

	/**
	 * Đ
	 */
	private UniqueMember member;

	/**
	 * bZ[W̒
	 */
	private int length;

	/**
	 * RXgN^
	 * @param shell eShell
	 * @param protocol vgR
	 * @param member Đ
	 * @param length bZ[W̒
	 */
	OnTooLongMessage(Shell shell, Protocol protocol, UniqueMember member,
			int length) {
		this.protocol = protocol;
		this.shell = shell;
		this.member = member;
		this.length = length;
	}

	/**
	 * bZ[W\AbZ[WEBhE
	 * gpłԂɂ܂B
	 */
	public void run() {

		Object[] args = new Object[] { member.getUserName(),
				new Integer(protocol.maxMessageLength), new Integer(length) };
		String msg = mm.get("OnTooLongMessage.message", args); //$NON-NLS-1$
		SWTUtils.showWarning(shell, msg);

		shell.setEnabled(true);
	}
}
