package petaclone.swt.logic;

import jp.takayuki.tools.MessageMap;
import petaclone.Message;
import petaclone.MessageStorage;
import petaclone.swt.SWTTaskTray;

/**
 * bZ[WMCxg
 * @author Takayuki Shoji
 */
public class SWTNewMessageReceived extends AbstractSWTEventListener {

	/**
	 * bZ[W\[X
	 */
	private static final MessageMap mm = MessageMap.getMessageMap();

	/**
	 * ^XNgC
	 */
	private SWTTaskTray tray;

	/**
	 * ۊǔ
	 */
	private MessageStorage storage;

	/**
	 * RXgN^
	 * @param display 
	 * @param tray ^XNgC
	 * @param storage ۊǔ
	 */
	public SWTNewMessageReceived(SWTTaskTray tray, MessageStorage storage) {
		this.tray = tray;
		this.storage = storage;
	}

	/**
	 * Cxg
	 */
	protected void handleEvent(String eventName, Object event) {
		Message message = (Message) event;

		// TODO ʒmC[W̃[hɎԂ邱Ƃ
		// ̂ŃobNOEhŃ[hłȂ
		tray.setNotifyImage();
		tray.showBalloon(
				mm.get("SWTNewMessageReceived.newMessage", //$NON-NLS-1$
						new Object[] {//
						new Integer(storage.getPendingCount()) }),//
				mm.get("SWTNewMessageReceived.senderAndTime", //$NON-NLS-1$
						new Object[] { message.userName, message.getDate() }),
				true);
	}
}
