package jp.takayuki.tools;

import java.io.File;
import java.io.FileFilter;

/**
 * vtBbNXƊgqvt@Ĉ݂tB^O܂B
 * @author Takayuki Shoji
 */
public class PrefixExtensionFilter implements FileFilter {

	/**
	 * 擪̕
	 */
	private String prefix;

	/**
	 * gq
	 */
	private String extension;

	/**
	 * RXgN^
	 * @param prefix 擪̕
	 * @param extension gq
	 */
	public PrefixExtensionFilter(String prefix, String extension) {
		this.prefix = prefix;
		this.extension = extension;
	}

	/**
	 * tB^
	 * @see FileFilter
	 */
	public boolean accept(File pathname) {
		if (!pathname.isFile()) {
			return false;
		}
		int length = prefix.length() + extension.length();
		// JnƏIԂĂꍇfalse
		String name = pathname.getName();
		if (name.length() < length) {
			return false;
		}

		if (!name.startsWith(prefix)) {
			return false;
		}
		if (!name.endsWith(extension)) {
			return false;
		}
		return true;
	}

}
