package jp.takayuki.tools;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.io.Writer;
import java.net.HttpURLConnection;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.nio.charset.Charset;
import java.security.MessageDigest;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import petaclone.swt.SWTMainWindow;

/**
 * ʂɗpł郁\bhW
 * @author Takayuki Shoji
 */
public class Tool {
	/**
	 * byte[]̎w肳ꂽʒu0oO܂ł̒߂܂B
	 * Amax𒴂ȂB
	 * @param sequence Ώۂ̔z
	 * @param start JEgJnCfbNX
	 * @param max JEg̍ől
	 * @return 0̑O܂ł̒
	 */
	public static int lengthToZero(byte[] sequence, int start, int max) {
		if (sequence.length <= start) {
			return 0;
		}
		int result;
		for (result = 0; result <= max && sequence.length > start + result
				&& sequence[start + result] != 0; result++) {

			// ȂɂȂ
		}
		return result;
	}

	/**
	 * oCgz񂩂w肳ꂽo
	 * CfbNX܂̓oCgz̒Ԃ܂B
	 * <p>
	 * \ȕbyte^ŕ\\Ȕ͈͂Ɍ܂B
	 * 
	 * @param sequence Ώۂ̃oCgz
	 * @param start Jnʒu(0)
	 * @param c 
	 * @return CfbNX
	 */
	public static int indexOf(byte[] sequence, int start, char c) {
		for (int i = start; i < sequence.length; i++) {
			if (sequence[i] == c) {
				return i;
			}
		}
		return sequence.length;
	}

	/**
	 * zAvl̃CfbNXԂ܂B
	 * @param array z
	 * @param search l
	 * @param length z̒
	 * @return vl̃CfbNXBvȂꍇ-1B
	 */
	public static int indexOf(int[] array, int search, int length) {
		for (int i = 0; i < length; i++) {
			if (array[i] == search) {
				return i;
			}
		}
		return -1;
	}

	/**
	 * ܂߂splitB؂p^[AĂĂ蕪܂B
	 * 󕶎𕪊悤Ƃꍇ̖߂l̗vf1B
	 * @param str Ώە
	 * @param pattern ؂蕶
	 * @return ؂蕶ŕ̔z
	 */
	public static String[] split(String str, String pattern) {
		ArrayList result = new ArrayList();
		//System.out.println("str.length()" + str.length());
		int beginIndex = 0;
		int endIndex = 0;
		while (beginIndex <= str.length()) {
			//System.out.println("1.begin:" + beginIndex + "end:" + endIndex);
			endIndex = str.indexOf(pattern, beginIndex);
			if (endIndex == -1) {
				endIndex = str.length();
			}
			//System.out.println("2.begin:" + beginIndex + "end:" + endIndex);
			String tmp;
			if (beginIndex != endIndex) {
				tmp = str.substring(beginIndex, endIndex);
			} else {
				//tmp = new String();
				tmp = ""; //$NON-NLS-1$
			}
			result.add(tmp);

			beginIndex = endIndex + pattern.length();
			//System.out.println(
			//	"3.begin:" + beginIndex + "end:" + endIndex + " tmp:" + tmp);
		}
		return (String[]) result.toArray(new String[result.size()]);
	}

	/**
	 * ܂߂splitB؂p^[AĂĂ蕪܂B
	 * @param str Ώۂ̕
	 * @param pattern ؂p^[
	 * @param max ő̗vf
	 * @return ؂蕶ŕ̔z
	 */
	public static String[] split(String str, String pattern, int max) {
		ArrayList result = new ArrayList();
		int beginIndex = 0;
		int endIndex = 0;
		while (beginIndex <= str.length()) {
			endIndex = str.indexOf(pattern, beginIndex);
			if (endIndex == -1 || (max > 0 && result.size() + 1 >= max)) {
				endIndex = str.length();
			}
			String tmp;
			if (beginIndex != endIndex) {
				tmp = str.substring(beginIndex, endIndex);
			} else {
				tmp = ""; //$NON-NLS-1$
			}
			result.add(tmp);

			beginIndex = endIndex + pattern.length();
		}
		return (String[]) result.toArray(new String[result.size()]);
	}

	/**
	 * ܂߂splitB؂蕶1B
	 * 
	 * @param str Ώۂ̕
	 * @param c ؂蕶
	 * @param max ő̗vf
	 * @return ؂蕶ŕ̔z
	 */
	public static String[] split(String str, char c, int max) {
		final int len = str.length();
		int size = 1;
		for (int i = 0; i < len; i++) {
			if (str.charAt(i) == c) {
				size++;
			}
		}
		if (max > 0) {
			size = Math.min(max, size);
		}

		String[] result = new String[size];

		int beginIndex = 0;
		int endIndex;
		for (int i = 0; i < size; i++) {
			if (i == size - 1) {
				endIndex = len;
			} else {
				endIndex = str.indexOf(c, beginIndex);
			}

			String tmp;
			if (beginIndex != endIndex) {
				tmp = str.substring(beginIndex, endIndex);
			} else {
				tmp = ""; //$NON-NLS-1$
			}
			result[i] = tmp;
			beginIndex = endIndex + 1;
		}
		return result;
	}

	/**
	 * @param str 
	 * @return s܂ޕ̔z
	 */
	public static String[] splitLines(String str) {
		ArrayList result = new ArrayList();
		int start = 0;
		int end = 0;
		for (int i = 0; i < str.length(); i++) {
			char c = str.charAt(i);
			switch (c) {
			case '\n':
				end = i + 1;
				result.add(str.substring(start, end));
				start = end;
				break;
			case '\r':
				if (i + 1 < str.length()) {
					if (str.charAt(i + 1) == '\n') {
						i++;
					}
				}
				end = i + 1;
				result.add(str.substring(start, end));
				start = end;
				break;
			}
		}
		result.add(str.substring(start));
		return (String[]) result.toArray(new String[result.size()]);
	}

	/**
	 * @param encoded %xxxxx%xxxxx...̕
	 * @return fR[h
	 */
	public static String decode(String encoded) {
		StringBuffer sb = new StringBuffer();
		String[] chars = Tool.split(encoded, '%', 0);
		for (int i = 0; i < chars.length; i++) {
			if (chars[i] == null || chars[i].length() == 0) {
				continue;
			}
			sb.append(valueToChar(chars[i]));
		}
		return sb.toString();
	}

	/**
	 * @param charValue %xxxxxxxxxx
	 * @return fR[h
	 */
	private static char valueToChar(String charValue) {
		char c = (char) Integer.parseInt(charValue);
		//System.out.println(">>"+c);
		return c;
	}

	/**
	 * w肵ׂĒu܂B
	 * @param str Ώەobt@
	 * @param from uOp^[
	 * @param to up^[
	 */
	public static void replaceAll(StringBuffer str, String from, String to) {
		for (int fromIndex = 0; fromIndex != -1; fromIndex += to.length()) {
			fromIndex = str.indexOf(from, fromIndex);
			if (fromIndex == -1) {
				return;
			}
			str.replace(fromIndex, fromIndex + from.length(), to);
		}
	}

	/**
	 * w肵ׂĒu܂B
	 * @param str Ώە
	 * @param from uOp^[
	 * @param to up^[
	 * @return u㕶
	 */
	public static String replaceAll(String str, String from, String to) {
		StringBuffer sb = new StringBuffer(str);
		replaceAll(sb, from, to);
		return sb.toString();
	}

	/**
	 * p^[Ƀ}b`L[Ƃ݂ȂĒlŒu܂B
	 * @param str Ώۂ̕
	 * @param ptn p^[
	 * @param group p^[̕ϐƂĎgpO[v
	 * @param context ϐ̃ReLXg
	 * @return u̕
	 */
	public static String replaceAll(String str, Pattern ptn, int group,
			Map context) {
		Matcher m = ptn.matcher(str);
		StringBuffer sb = new StringBuffer(str.length() + 128);
		while (m.find()) {
			String key = m.group(group);
			String val = (String) context.get(key);
			val = val == null ? "" : val; //$NON-NLS-1$
			val = Matcher.quoteReplacement(val);
			m.appendReplacement(sb, val);
		}
		m.appendTail(sb);
		return sb.toString();
	}

	/**
	 * byte16i̕ɂ܂B
	 * @param b oCg
	 * @return 
	 */
	public static String byteToHexString(byte b) {
		int num = b;
		if (num < 0) {
			num += 256;
		}
		if (num < 0x10) {
			return "0" + Integer.toHexString(num); //$NON-NLS-1$
		}

		return Integer.toHexString(num);
	}

	/**
	 * 216iɕϊStringBufferɒǉ܂B
	 * @param sb obt@
	 * @param i (0`255)
	 */
	public static void intToHexString(StringBuffer sb, int i) {
		String hex = Integer.toHexString(i);
		if (hex.length() == 1) {
			sb.append('0');
		}
		sb.append(hex);
	}

	/**
	 * rbOGfBAbyte[4]longɕϊ܂B
	 * @param integer 4oCgȏbytez
	 * @param start ϊJnintegerz񒆂̈ʒu
	 * @return ϊꂽ32rbg
	 */
	public static int byteToIntBigEndian(byte[] integer, int start) {
		int result = 0;
		for (int i = start; i < start + 4; i++) {
			result = result << 8;
			result += unsignedByteToInt(integer[i]);
		}
		return result;
	}

	/**
	 * gGfBAbyte[4]intɕϊ܂B
	 * @param integer 4oCgȏbytez
	 * @param start ϊJnintegerz񒆂̈ʒu
	 * @return ϊꂽint^̐l
	 */
	public static int byteToInt(byte[] integer, int start) {
		int result = 0;
		//System.out.println("start:"+start);
		for (int i = start + 3; i > start; i--) {
			//System.out.println("i:"+i+" integer[i]:"+integer[i]);
			result += unsignedByteToInt(integer[i]);
			result = result << 8;
		}
		result += unsignedByteToInt(integer[start]);
		//System.out.println("result:"+result+", integer["+start+"]:"+integer[start]);
		return result;
	}

	/**
	 * gGfBAbyte[2]intɕϊ܂B
	 * @param bytes 2oCgȏbytez
	 * @param start ϊJnintegerz񒆂̈ʒu
	 * @return ϊꂽint^̐l
	 */
	public static int bytesToShort(byte[] bytes, int start) {
		int result = 0;
		for (int i = start + 1; i > start; i--) {
			result += unsignedByteToInt(bytes[i]);
			result = result << 8;
		}
		result += unsignedByteToInt(bytes[start]);
		return result;
	}

	/**
	 * byte𕄍ȂƂ݂Ȃintɂ܂B
	 * @param b oCg
	 * @return intl
	 */
	public static int unsignedByteToInt(byte b) {
		int result = b;
		if (result < 0) {
			result += 256;
		}
		return result;
	}

	/**
	 * GfBAt]܂B
	 * @param value 16rbg
	 * @return GfBAt]
	 */
	public static int exchangeEndian(int value) {
		assert value >= 0 && value < 0x10000;
		return (value & 0x00ff) * 256 | (value >>> 8);
	}

	/**
	 * RZ~RɃGXP[v܂B
	 * @param str Ώۂ̕
	 * @return RZ~Rɒuꂽ
	 */
	public static String escapeColon(String str) {
		if (str == null) {
			return null;
		}
		if (str.indexOf(':') == -1) {
			return str;
		}
		StringBuffer sb = new StringBuffer(str);
		Tool.replaceAll(sb, ":", ";"); //$NON-NLS-1$ //$NON-NLS-2$
		return sb.toString();
	}

	/**
	 * valuedpň݂͂܂B
	 * valueɊ܂܂dp͓̓dpɃGXP[v܂B
	 * @param out o͐
	 * @param value dpň͂ޕ
	 */
	public static void escapeDoubleQuotation(StringBuffer out, String value) {
		if (value == null || value.length() == 0) {
			out.append("\"\""); //$NON-NLS-1$
			return;
		}
		out.append('"');
		for (int i = 0; i < value.length(); i++) {
			char c = value.charAt(i);
			switch (c) {
			case '"':
				out.append("\"\""); //$NON-NLS-1$
				break;
			default:
				out.append(c);
				break;
			}
		}
		out.append('"');
	}

	/**
	 * TODO gĂȂ
	 * 
	 * valuedpň݂͂܂B
	 * valueɊ܂܂dp\ŃGXP[v܂B
	 * @param out o͐
	 * @param value dpň͂ޕ
	 */
	public static void escapeDoubleQuotation2(StringBuffer out, String value) {
		if (value == null || value.length() == 0) {
			out.append("\"\""); //$NON-NLS-1$
			return;
		}
		out.append('"');
		for (int i = 0; i < value.length(); i++) {
			char c = value.charAt(i);
			switch (c) {
			case '"':
				out.append("\\\""); //$NON-NLS-1$
				break;
			case '\\':
				out.append("\\\\"); //$NON-NLS-1$
				break;
			default:
				out.append(c);
				break;
			}
		}
		out.append('"');
	}

	/**
	 * Rg[GXP[vĕ񉻂܂B
	 * @param buf ϊΏ
	 * @return GXP[vςݕ
	 */
	public static String escapeControl(byte[] buf) {
		StringBuffer sb = new StringBuffer((int) (buf.length * 1.1));
		for (int i = 0; i < buf.length; i++) {
			int v = buf[i] & 0x000000FF;
			if (v == '\\') {
				sb.append("\\\\"); //$NON-NLS-1$
			} else if (0x20 <= v && v <= 0x7F) {
				sb.append((char) buf[i]);
			} else if (v <= 0x0F) {
				sb.append("\\x0").append(Integer.toHexString(v).toUpperCase()); //$NON-NLS-1$
			} else {
				sb.append("\\x").append(Integer.toHexString(v)); //$NON-NLS-1$
			}
		}
		return sb.toString();
	}

	/**
	 * QƂւ̕ϊB&lt;&amp;lt;ɕϊ悤ȏB
	 * @param str Ώەobt@
	 */
	public static void escape(StringBuffer str) {
		for (int i = 0; i < str.length(); i++) {
			char c = str.charAt(i);
			switch (c) {
			case '&':
				str.replace(i, i + 1, "&amp;"); //$NON-NLS-1$
				i += 4;
				break;
			case '<':
				str.replace(i, i + 1, "&lt;"); //$NON-NLS-1$
				i += 3;
				break;
			case '>':
				str.replace(i, i + 1, "&gt;"); //$NON-NLS-1$
				i += 3;
				break;
			case '"':
				str.replace(i, i + 1, "&quot;"); //$NON-NLS-1$
				i += 5;
				break;
			case '\'':
				str.replace(i, i + 1, "&apos;"); //$NON-NLS-1$
				i += 5;
				break;
			default:
				break;
			}
		}
	}

	/**
	 * QƂւ̕ϊB&lt;&amp;lt;ɕϊ悤ȏB
	 * @param str Ώە
	 * @return ϊ㕶
	 */
	public static String escape(String str) {
		StringBuffer sb = new StringBuffer();
		escape(sb, str);
		return sb.toString();
	}

	/**
	 * QƂւ̕ϊB&lt;&amp;lt;ɕϊ悤ȏB
	 * @param sb o͐
	 * @param str ϊΏۂ̕
	 */
	public static void escape(StringBuffer sb, String str) {
		for (int i = 0; i < str.length(); i++) {
			char c = str.charAt(i);
			switch (c) {
			case '&':
				sb.append("&amp;"); //$NON-NLS-1$
				break;
			case '<':
				sb.append("&lt;"); //$NON-NLS-1$
				break;
			case '>':
				sb.append("&gt;"); //$NON-NLS-1$
				break;
			case '"':
				sb.append("&quot;"); //$NON-NLS-1$
				break;
			case '\'':
				sb.append("&apos;"); //$NON-NLS-1$
				break;
			default:
				sb.append(c);
				break;
			}
		}
	}

	/**
	 * WriterstrXMLGXP[vȂo͂܂B
	 * @param w o͐
	 * @param str 
	 * @throws IOException 
	 */
	public static void escapeXml(Writer w, String str) throws IOException {
		if (str == null) {
			return;
		}
		for (int i = 0; i < str.length(); i++) {
			char c = str.charAt(i);
			switch (c) {
			case '&':
				w.write("&amp;"); //$NON-NLS-1$
				break;
			case '<':
				w.write("&lt;"); //$NON-NLS-1$
				break;
			case '>':
				w.write("&gt;"); //$NON-NLS-1$
				break;
			case '"':
				w.write("&quot;"); //$NON-NLS-1$
				break;
			case '\'':
				w.write("&apos;"); //$NON-NLS-1$
				break;
			default:
				w.write(c);
				break;
			}
		}
	}

	/**
	 * Jn^Oo͂܂B
	 * @param w o͐
	 * @param name vf
	 * @throws IOException 
	 */
	public static void writeStartElement(Writer w, String name)
			throws IOException {
		w.write('<');
		w.write(name);
		w.write('>');
	}

	/**
	 * I^Oo͂܂B
	 * @param w o͐
	 * @param name vf
	 * @throws IOException 
	 */
	public static void writeEndElement(Writer w, String name)
			throws IOException {
		w.write('<');
		w.write('/');
		w.write(name);
		w.write('>');
	}

	/**
	 * vfo͂܂B
	 * @param w o͐
	 * @param element vf
	 * @param content e
	 * @throws IOException
	 */
	public static void writeElement(Writer w, String element, String content)
			throws IOException {
		writeStartElement(w, element);
		Tool.escapeXml(w, content);
		writeEndElement(w, element);
	}

	/**
	 * vfo͂܂B
	 * @param w o͐
	 * @param element vf
	 * @param content e
	 * @throws IOException
	 */
	public static void writeElement(Writer w, String element, boolean content)
			throws IOException {
		writeStartElement(w, element);
		if (content) {
			w.write('1');
		} else {
			w.write('0');
		}
		writeEndElement(w, element);
	}

	/**
	 * Fo͂܂B
	 * @param w o͐
	 * @param element vf
	 * @param values l
	 * @throws IOException
	 */
	public static void writeColor(Writer w, String element, int[] values)
			throws IOException {
		writeStartElement(w, element);
		w.write(Integer.toString(values[0]));
		w.write(',');
		w.write(Integer.toString(values[1]));
		w.write(',');
		w.write(Integer.toString(values[2]));
		writeEndElement(w, element);
	}

	/**
	 * gpłȂt@C
	 */
	private static final String[] tabooName;

	/**
	 * gpłȂt@C̃p^[
	 */
	private static final Pattern tabooNamePattern;

	/**
	 * gpłȂ
	 */
	private static final char[] tabooChars;
	static {
		// vbgtH[̎擾
		if (Os.isWindows()) {
			tabooNamePattern = Pattern.compile(
					"(^(aux|con|nul|prn)$)|(^(com|lpt)[1-9]$)", //$NON-NLS-1$
					Pattern.CASE_INSENSITIVE);

			tabooName = null;
			tabooChars = new char[] { '\\', '/', ':', '*', '?', '"', '<', '>',
					'|' };
		} else if (Os.isMacOSX()) {
			tabooNamePattern = null;
			tabooName = new String[] { ".", ".." }; //$NON-NLS-1$ //$NON-NLS-2$
			tabooChars = new char[] { '/', ':' };
		} else {
			tabooNamePattern = null;
			// Linux, FreeBSD, Solaris, ...
			tabooName = new String[] { ".", ".." }; //$NON-NLS-1$ //$NON-NLS-2$
			tabooChars = new char[] { '/' };
		}
	}

	/**
	 * 납猟ăsIhƃXy[XARg[R[hȊO̕oʒuԂ܂B
	 * 
	 * @param str 
	 * @return ʒuBׂăsIhƃXy[X̏ꍇ
	 */
	private static int lastIndexOfNonePeriodSpace(String str) {
		for (int i = str.length() - 1; i >= 0; i--) {
			char c = str.charAt(i);
			if (c > 32 && c != '.' && !Character.isISOControl(c)) {
				return i;
			}
		}
		// ׂĎgȂ
		return -1;
	}

	/**
	 * Win32vbgtH[̃t@C̈Ss܂B
	 * 
	 * @param filename t@C
	 * @return Sȃt@C
	 */
	private static String validateFileNameWin32(String filename) {

		// t@C̖ɎgȂ폜
		int pos = lastIndexOfNonePeriodSpace(filename);
		if (pos == -1) {
			return "_"; //$NON-NLS-1$
		}
		String trimed;
		if (pos == filename.length() - 1) {
			trimed = filename;
		} else {
			trimed = filename.substring(0, pos + 1);
		}

		// gq̑O擾
		int dot = trimed.indexOf('.');
		String name, ext;
		if (dot == -1) {
			name = trimed;
			ext = null;
		} else {
			name = trimed.substring(0, dot);
			ext = trimed.substring(dot + 1);
		}

		// O̖Q
		Matcher m = tabooNamePattern.matcher(name);
		if (m.find()) {
			name = name + "_"; //$NON-NLS-1$
		}

		// gq߂
		if (ext != null) {
			name = name + "." + ext; //$NON-NLS-1$
		}

		return escapeTabooChars(name);
	}

	/**
	 * Win32ȊÕvbgtH[̃t@C̈Ss܂B
	 * 
	 * @param file t@C
	 * @return Sȃt@C
	 */
	private static String validateFileNameOther(String file) {

		// O̖Q
		String file2 = file.trim();
		for (int i = 0; i < tabooName.length; i++) {
			if (file2.equals(tabooName[i])) {
				return file2 + "_"; //$NON-NLS-1$
			}
		}
		return escapeTabooChars(file2);
	}

	/**
	 * 䕶ƃvbgtH[Ƃ̋֎~GXP[v܂B
	 * 
	 * @param name t@C
	 * @return GXP[vꂽt@C
	 */
	private static String escapeTabooChars(String name) {
		// ̃`FbN
		StringBuffer sb = new StringBuffer();
		for (int i = 0; i < name.length(); i++) {
			char c = name.charAt(i);
			// 䕶
			if (Character.isISOControl(c)) {
				sb.append('_');
				continue;
			}
			// w肳ꂽ
			int n;
			for (n = 0; n < tabooChars.length; n++) {
				if (c == tabooChars[n]) {
					break;
				}
			}
			if (n == tabooChars.length) {
				sb.append(c);
			} else {
				sb.append('_');
			}
		}
		return sb.toString();
	}

	/**
	 * vbgtH[ɉăt@CȂ悤ɕϊ܂B
	 * 
	 * @param file t@C
	 * @return ϊt@C
	 */
	public static String validateFileName(String file) {

		switch (Os.getId()) {
		case Os.WINDOWS:
			return validateFileNameWin32(file);
		case Os.MACOSX:
		case Os.OTHER:
		default:
			return validateFileNameOther(file);
		}
	}

	/**
	 * gq擾܂B.܂݂܂B
	 * @param path pX
	 * @return gq
	 */
	public static String getExtention(String path) {
		File f = new File(path);
		String name = f.getName();

		int index = name.lastIndexOf('.');
		if (index != -1) {
			return name.substring(index);
		}
		return ""; //$NON-NLS-1$
	}

	/**
	 * dȂt@CŃt@C쐬܂B
	 * 쐬łȂꍇname(count).ext`ōĎs܂B
	 * @param parentDir 쐬t@C̐efBNg
	 * @param filename ɂȂt@C
	 * @param retry Ďs
	 * @return 쐬t@CBsꍇnullԂ܂B
	 */
	public static File createUniqueFile(File parentDir, String filename,
			int retry) {
		if (!parentDir.isDirectory()) {
			return null;
		}
		if (filename == null || filename.length() == 0) {
			return null;
		}

		String name;
		String ext;
		int index = filename.lastIndexOf('.');
		if (index != -1) {
			name = filename.substring(0, index);
			ext = filename.substring(index);
		} else {
			name = filename;
			ext = ""; //$NON-NLS-1$
		}

		for (int i = 0; i < retry; i++) {
			File f = new File(parentDir, makeFilename(name, ext, i + 1));
			try {
				if (f.createNewFile()) {
					return f;
				}
			} catch (IOException e) {
				e.printStackTrace();
				return null;
			}
		}

		return null;
	}

	/**
	 * dȂOŃfBNg쐬܂B
	 * 쐬łȂꍇname(count)`ōĎs܂B
	 * @param parentDir 쐬t@C̐efBNg
	 * @param dirname ɂȂfBNg
	 * @param retry Ďs
	 * @return 쐬t@CBsꍇnullԂ܂B
	 */
	public static File createUniqueDierectory(File parentDir, String dirname,
			int retry) {
		if (!parentDir.isDirectory()) {
			return null;
		}
		if (dirname == null || dirname.length() == 0) {
			return null;
		}

		for (int i = 0; i < retry; i++) {
			File f = new File(parentDir, makeFilename(dirname, "", i + 1)); //$NON-NLS-1$
			if (f.mkdir()) {
				return f;
			}
		}

		return null;
	}

	/**
	 * t@CfBNgɈړ܂B
	 * fBNgɓ̃t@CfBNgꍇ
	 * l[čĎs܂B
	 * @param from ړΏۂ̃t@C܂̓fBNg
	 * @param destDir ړ̃fBNg
	 * @param retry Ďs
	 * @return l[̃t@CBl[ɎsꍇnullB
	 * 	܂AfromdestDir݂ȂꍇAdestDirfBNgł
	 * 	ȂꍇnullԂ܂B
	 */
	public static File move(File from, File destDir, int retry) {
		if (!from.exists()) {
			// ݂Ȃꍇ̓l[łȂ
			return null;
		}

		// ړ̊mF
		if (!destDir.exists() || !destDir.isDirectory()) {
			return null;
		}

		// OƊgqɕ
		String fullname = from.getName();
		int index = fullname.lastIndexOf('.');
		String name, ext;
		if (from.isDirectory() || index <= 0) {
			// fBNg܂.Ŏn܂邩.t@C
			name = fullname;
			ext = ""; //$NON-NLS-1$
		} else {
			name = fullname.substring(0, index);
			ext = fullname.substring(index);
		}

		// ړ
		for (int i = 0; i < retry; i++) {
			File renamed = new File(destDir, makeFilename(name, ext, i + 1));
			if (from.renameTo(renamed)) {
				return renamed;
			}
		}
		return null;
	}

	/**
	 * JEgɉt@CĕԂ܂B<br>
	 * name(count).ext<br>
	 * Acount==0,1̂Ƃname.extԂ܂BB
	 * @param name gqt@C
	 * @param ext gq
	 * @param count JE^[
	 * @return ꂽt@C
	 */
	private static String makeFilename(String name, String ext, int count) {
		StringBuffer sb = new StringBuffer(name);
		if (count >= 2) {
			sb.append("(").append(count).append(")"); //$NON-NLS-1$ //$NON-NLS-2$
		}
		sb.append(ext);
		return sb.toString();
	}

	/**
	 * X^bNg[X̕
	 * @param th OAG[
	 * @return 񉻂ꂽX^bNg[X
	 */
	public static String getStackTraceString(Throwable th) {
		if (th == null) {
			return ""; //$NON-NLS-1$
		}
		StringWriter writer = new StringWriter();
		th.printStackTrace(new PrintWriter(writer));
		return writer.toString();
	}

	/**
	 * oCg16iɕϊ܂B
	 * (based on Digitune IP Messenger)
	 * @param b oCgz
	 * @return 16i
	 */
	public static String bytesToHexString(byte[] b) {
		StringBuffer strbuf = new StringBuffer();
		for (int i = 0; i < b.length; i++) {
			int tmpb = (b[i] < 0) ? b[i] + 0x100 : b[i];
			strbuf.append(Integer.toString(tmpb / 16, 16).toUpperCase());
			strbuf.append(Integer.toString(tmpb % 16, 16).toUpperCase());
		}
		return strbuf.toString();
	}

	/**
	 * 16ioCgɕϊ܂B
	 * (based on Digitune IP Messenger)
	 * @param src 16i
	 * @return oCgz
	 */
	public static byte[] hexStringToBytes(String src) {
		if (src.length() % 2 != 0) {
			throw new IllegalArgumentException(
					"Length of the argument src must be even."); //$NON-NLS-1$
		}
		byte[] buf = new byte[src.length() / 2];
		for (int i = 0; i < src.length(); i += 2) {
			int b;
			b = Integer.parseInt(src.substring(i,
					((i + 2) > src.length()) ? src.length() : i + 2), 16);
			if (b > 127) {
				b -= 0x100;
			}
			buf[i / 2] = (byte) b;
		}
		return buf;
	}

	/**
	 * sɈpbZ[WԂ܂B
	 * @param text p镶
	 * @param quoteString p
	 * @param insertNewLineToHead 擪ɉs2
	 * @return pꂽ
	 */
	public static String getQuotedText(String text, String quoteString,
			boolean insertNewLineToHead) {
		if (text == null || text.length() == 0) {
			return ""; //$NON-NLS-1$
		}
		if (quoteString == null) {
			quoteString = ""; //$NON-NLS-1$
		}

		StringBuffer sb = new StringBuffer();
		if (insertNewLineToHead) {
			sb.append(System.getProperty("line.separator")); //$NON-NLS-1$
			sb.append(System.getProperty("line.separator")); //$NON-NLS-1$
		}
		sb.append(quoteString);
		char prev = 0;
		for (int i = 0; i < text.length(); i++) {
			if (prev == '\n') {
				sb.append(quoteString);
			}
			char c = text.charAt(i);
			sb.append(c);
			prev = c;
		}
		// Ō͉s
		if (prev != '\n' && prev != '\r' && prev != 0) {
			sb.append(System.getProperty("line.separator")); //$NON-NLS-1$
		}
		return sb.toString();
	}

	/**
	 * sł͂Ȃŏ1s擾܂B
	 * @param text Ώە
	 * @param max ő啶
	 * @return sł͂Ȃŏ1s
	 */
	public static String getFirstLine(String text, int max) {
		int from = 0;
		while (from < text.length()
				&& (text.charAt(from) == '\n' || text.charAt(from) == '\r')) {
			from++;
		}
		if (from == text.length()) {
			return ""; //$NON-NLS-1$
		}

		int posN = text.indexOf("\n", from); //$NON-NLS-1$
		int posR = text.indexOf("\r", from); //$NON-NLS-1$
		int end;
		if (posN == -1)
			end = posR;
		else if (posR == -1)
			end = posN;
		else
			end = posR < posN ? posR : posN;

		if (end == -1) {
			//from = 0;
			end = text.length();
		}
		if (end - from > max) {
			end = from + max;
		}
		return text.substring(from, end);
	}

	/**
	 * ̐擪Xy[XĎ擾܂B
	 * 
	 * @param text 
	 * @param max 
	 * @return 
	 */
	public static String head(String text, int max) {
		if (text == null) {
			return ""; //$NON-NLS-1$
		}
		StringBuffer sb = new StringBuffer(max);

		boolean space = false;
		text = text.trim();
		for (int i = 0; i < text.length(); i++) {
			char c = text.charAt(i);
			if (Character.isISOControl(c) || c == ' ') {
				if (!space) {
					sb.append(' ');
					space = true;
				}
			} else {
				space = false;
				sb.append(c);
			}
			if (sb.length() >= max) {
				break;
			}
		}
		return sb.toString();
	}

	/**
	 * ToolTipTextɐݒ肷邽߂&amp;GXP[v܂B
	 * @param plain v[eLXg
	 * @return GXP[vꂽ
	 */
	public static String escapeSWTToolTipText(String plain) {
		if (plain == null || plain.length() == 0) {
			return ""; //$NON-NLS-1$
		}
		if (plain.indexOf('&') == -1) {
			return plain;
		}
		return plain.replaceAll("(&+)", "&$1$1"); //$NON-NLS-1$ //$NON-NLS-2$
	}

	/**
	 * Labelɐݒ肷邽߂&amp;GXP[v܂B
	 * @param plain v[eLXg
	 * @return GXP[vꂽ
	 */
	public static String escapeSWTLabelText(String plain) {
		if (plain == null || plain.length() == 0) {
			return ""; //$NON-NLS-1$
		}
		if (plain.indexOf('&') == -1) {
			return plain;
		}
		return replaceAll(plain, "&", "&&"); //$NON-NLS-1$ //$NON-NLS-2$
	}

	/**
	 * w肵TCYobt@ɓǂݍ݂܂B
	 * @param r ̓Xg[
	 * @param buf f[^i[obt@
	 * @param length ǂݍލőTCY
	 * @return ǂݍ񂾃TCYB
	 * 		EOF̏ꍇAobt@TCYȂB
	 * @throws IOException 
	 * @throws IllegalArgumentException buflengthꍇ
	 */
	public static int readComplete(InputStream r, byte[] buf, int length)
			throws IOException {
		if (buf.length < length) {
			throw new IllegalArgumentException("buf is too short."); //$NON-NLS-1$
		}
		int readSize = 0;
		while (true) {
			int added = r.read(buf, readSize, length - readSize);
			if (added == -1) {
				return readSize;
			}
			readSize += added;
			if (readSize >= length)
				break;
		}
		return readSize;
	}

	/**
	 * obt@ɂׂēǂݍ݂܂B
	 * @param r ̓Xg[
	 * @param buf f[^i[obt@
	 * @return ǂݍ񂾃TCYB
	 * 		EOF̏ꍇAobt@TCYȂB
	 * @throws IOException 
	 */
	public static int readComplete(InputStream r, byte[] buf)
			throws IOException {
		return readComplete(r, buf, buf.length);
	}

	/**
	 * ̓Xg[ׂēǂݍStringŕԂ܂B
	 * @param in ̓Xg[
	 * @param bufSize ǂݍ݂Ɏgpobt@TCY
	 * @param cs Zbg
	 * @return ǂݍ񂾕
	 * @throws IOException
	 */
	public static String readComplete(InputStream in, int bufSize, Charset cs)
			throws IOException {
		ByteList list = new ByteList(bufSize);
		byte[] buf = new byte[bufSize];
		while (true) {
			int size = readComplete(in, buf);
			list.add(buf, size);
			if (size < buf.length) {
				break;
			}
		}
		return list.toString(cs);
	}

	/**
	 * org.apache.commons.lang.StringUtils#equals(String,String)
	 * @param str1  the first String, may be null
	 * @param str2  the second String, may be null
	 * @return <code>true</code> if the Strings are equal, case sensitive, or
	 *  both <code>null</code>
	 */
	public static boolean equals(String str1, String str2) {
		return str1 == null ? str2 == null : str1.equals(str2);
	}

	/**
	 * org.apache.commons.lang.StringUtils#equalsIgnoreCase(String,String)
	 * @param str1  the first String, may be null
	 * @param str2  the second String, may be null
	 * @return <code>true</code> if the Strings are equal, case insensitive, or
	 *  both <code>null</code>
	 */
	public static boolean equalsIgnoreCase(String str1, String str2) {
		return str1 == null ? str2 == null : str1.equalsIgnoreCase(str2);
	}

	/**
	 * IuWFNgr܂BnullZ[tłB
	 * @param obj1 IuWFNg1
	 * @param obj2 IuWFNg2
	 * @return IuWFNg1傫ꍇ͐Aꍇ͕Aꍇ0Ԃ܂B
	 */
	public static int compareTo(Comparable obj1, Comparable obj2) {
		if (obj1 == obj2) {
			return 0;
		}
		if (obj1 == null) {
			return -1;
		}
		if (obj2 == null) {
			return 1;
		}
		return obj1.compareTo(obj2);
	}

	/**
	 * 啶Ə𖳎ĕr܂BnullZ[tłB
	 * @param str1 1
	 * @param str2 2
	 * @return 1傫ꍇ͐Aꍇ͕Aꍇ0Ԃ܂B
	 */
	public static int compareToIgnoreCase(String str1, String str2) {
		if (str1 == null && str2 == null) {
			return 0;
		}
		if (str1 == null) {
			return -1;
		}
		if (str2 == null) {
			return 1;
		}
		return str1.compareToIgnoreCase(str2);
	}

	/**
	 * tOĂ邩܂B
	 * @param value Ώۂ̒l
	 * @param flag tO
	 * @return w肵flag̃rbĝA
	 * valuẽrbĝꂩ1̏ꍇAtrueԂ܂B
	 */
	public static boolean hasFlag(long value, long flag) {
		return (value & flag) != 0;
	}

	/**
	 * tOĂ邩܂B
	 * @param value Ώۂ̒l
	 * @param flag tO
	 * @return w肵flag̃rbĝA
	 * valuẽrbĝꂩ1̏ꍇAtrueԂ܂B
	 */
	public static boolean hasFlag(int value, int flag) {
		return (value & flag) != 0;
	}

	/**
	 * JavaW[o[W
	 */
	private static int javaMajor;

	/**
	 * Java}Ci[o[W
	 */
	private static int javaMinor;
	static {
		int major = 0;
		int minor = 0;
		try {
			String[] v = System.getProperty("java.version").split("\\."); //$NON-NLS-1$ //$NON-NLS-2$
			major = Integer.parseInt(v[0]);
			if (v.length >= 2) {
				minor = Integer.parseInt(v[1]);
			}
		} catch (NumberFormatException e) {
			e.printStackTrace();
		}
		javaMajor = major;
		javaMinor = minor;
		//System.out.println(javaMajor);
		//System.out.println(javaMinor);
	}

	/**
	 * Java5ȍ~̂Ƃtrue
	 */
	public static final boolean javaVersion1_5_orHigher = minJavaVersion(1, 5);

	/**
	 * Java6ȍ~̂Ƃtrue
	 */
	public static final boolean javaVersion1_6_orHigher = minJavaVersion(1, 6);

	/**
	 * Œo[W𖞂Ă邩ǂԂ܂B
	 * @param major W[o[W
	 * @param minor }Ci[o[W
	 * @return Œo[W𖞂Ăꍇtrue
	 */
	private static boolean minJavaVersion(int major, int minor) {
		if (javaMajor > major || javaMajor >= major && javaMinor >= minor) {
			return true;
		}
		return false;

	}

	/**
	 * w肳ꂽsR[hɓꂵeLXg擾܂B
	 * @param src ݒ肵悤ƂeLXg
	 * @param delimiter sR[h
	 * @return sR[hϊꂽeLXg
	 */
	public static String convertLineDelimiter(String src, String delimiter) {
		if (delimiter == null) {
			return src;
		}
		if (src == null || src.length() == 0) {
			return src;
		}
		StringBuffer sb = new StringBuffer(src);
		Tool.replaceAll(sb, "\r\n", "\n"); //$NON-NLS-1$ //$NON-NLS-2$
		Tool.replaceAll(sb, "\r", "\n"); //$NON-NLS-1$ //$NON-NLS-2$
		Tool.replaceAll(sb, "\n", delimiter); //$NON-NLS-1$
		return sb.toString();
	}

	/**
	 * sR[h\nƉ肵ăCfbNXϊ܂B
	 * 
	 * @param platformIndex vbgtH[ˑ̉sR[hgpĂƂ̃CfbNX
	 * @param textBoxText eLXg{bNX̃eLXg
	 * @param delim eLXg{bNX̉sR[h
	 * @return sR[h\nƂꍇ̃CfbNX
	 */
	public static int getStorableIndex(int platformIndex, String textBoxText,
			String delim) {
		if (delim.length() == 1 || platformIndex == 0) {
			return platformIndex;
		}

		int count = 0;
		int pos = 0;
		while ((pos = textBoxText.indexOf(delim, pos)) != -1) {
			if (pos >= platformIndex) {
				break;
			}
			count++;
			pos += delim.length();
		}
		return platformIndex - count;
	}

	/**
	 * sR[h\nƉ肵ꍇ̃CfbNX
	 * vbgtH[ˑ̉sR[hgpꍇ̃CfbNXɕϊ܂B
	 * 
	 * @param storableIndex sR[h\nƂꍇ̃CfbNX
	 * @param textBoxText eLXg{bNX̃eLXg(sR[h̓vbgtH[ˑ)
	 * @param delim eLXg{bNX̉sR[h
	 * @return vbgtH[ˑ̉sR[hgpĂƂ̃CfbNX
	 */
	public static int getPlatformIndex(int storableIndex, String textBoxText,
			String delim) {
		if (delim.length() == 1 || storableIndex == 0) {
			return storableIndex;
		}

		int pos = 0;
		while ((pos = textBoxText.indexOf(delim, pos)) != -1) {
			if (pos >= storableIndex) {
				break;
			}
			storableIndex++;
			pos += delim.length();
		}
		return storableIndex;
	}

	/**
	 * intBig endian 32rbgƂăoCgzɏ݂܂B
	 * @param bytes oCgz
	 * @param start ݊JnCfbNX
	 * @param value l
	 */
	public static void writeInt32BigEndian(byte[] bytes, int start, int value) {
		bytes[start] = (byte) ((value >> 24) & 0x000000FF);
		bytes[start + 1] = (byte) ((value >> 16) & 0x000000FF);
		bytes[start + 2] = (byte) ((value >> 8) & 0x000000FF);
		bytes[start + 3] = (byte) (value & 0x000000FF);
	}

	/**
	 * intLittle endian 16rbgƂăoCgzɏ݂܂B
	 * @param bytes oCgz
	 * @param start ݊JnCfbNX
	 * @param value l
	 */
	public static void writeInt16LittleEndian(byte[] bytes, int start, int value) {
		bytes[start + 1] = (byte) ((value >> 8) & 0x000000FF);
		bytes[start] = (byte) (value & 0x000000FF);
	}

	/**
	 * intLittle endian 32rbgƂăoCgzɏ݂܂B
	 * @param bytes oCgz
	 * @param start ݊JnCfbNX
	 * @param value l
	 */
	public static void writeInt32LittleEndian(byte[] bytes, int start, int value) {
		bytes[start + 3] = (byte) ((value >> 24) & 0x000000FF);
		bytes[start + 2] = (byte) ((value >> 16) & 0x000000FF);
		bytes[start + 1] = (byte) ((value >> 8) & 0x000000FF);
		bytes[start] = (byte) (value & 0x000000FF);
	}

	/**
	 * NFD`NFC`ɐK܂B
	 * 
	 * @param str NFD
	 * @return NFC
	 */
	public static String normalize(CharSequence str) {
		if (javaVersion1_6_orHigher) {
			return java.text.Normalizer.normalize(str,
					java.text.Normalizer.Form.NFC);
		}
		return Normalizer.normalize(str);
	}

	/**
	 * J}؂̐(int)̕int̔zɕϊĕԂ܂B
	 * @param str J}؂蕶
	 * @return int̔zBϊłȂꍇnullB
	 */
	public static int[] parseIntArray(String str) {
		if (str == null || str.length() == 0) {
			return null;
		}
		String[] numstr = Tool.split(str, ',', 0);
		if (numstr.length == 0) {
			return null;
		}
		try {
			int[] result = new int[numstr.length];
			for (int i = 0; i < numstr.length; i++) {
				result[i] = Integer.parseInt(numstr[i]);
			}
			return result;
		} catch (NumberFormatException e) {
			return null;
		}
	}

	/**
	 * HTML̐F\LRGB̐̔zɕϊ܂B
	 * @param ffffff 
	 * @return ʂ2-4oCg8bitintz
	 * @throws NumberFormatException ffffff𐮐ɕϊłȂꍇ
	 */
	public static int[] parseInt24(String ffffff) throws NumberFormatException {
		int num = Integer.parseInt(ffffff, 16);
		return new int[] { num >> 16 & 0xFF, num >> 8 & 0xFF, num & 0xFF };
	}

	/**
	 * RGB̐̔zHTML̐F\Lɕϊ܂B
	 * @param rgb 0-255͈̗̔͂vf3̔z
	 * @param defaultString rgbȂꍇɕԂ
	 * @return FFFFFF`
	 */
	public static String formatInt24(int[] rgb, String defaultString) {
		if (rgb == null || rgb.length < 3) {
			return defaultString;
		}
		StringBuffer sb = new StringBuffer(6);
		for (int i = 0; i < 3; i++) {
			intToHexString(sb, rgb[i]);
		}
		return sb.toString();
	}

	/**
	 * PʂŕR[ho͂܂B
	 * @param out o͐
	 * @param str 
	 */
	public static void dumpCharCode(StringBuffer out, String str) {
		if (str == null) {
			out.append("null"); //$NON-NLS-1$
			return;
		}
		final int len = str.length();
		for (int i = 0; i < len; i++) {
			final char c = str.charAt(i);
			out.append(Integer.toHexString(c));
			out.append(' ');
			if (!Character.isISOControl(c)) {
				out.append(c);
				out.append(' ');
			}
		}
	}

	/**
	 * \[XpXŎ郊\[XXg[ɏo͂܂B
	 * 
	 * @param out o̓Xg[
	 * @param resourcePath \[XpX(΃pX)
	 * @throws IOException o͗O܂̓\[X݂ȂꍇB
	 */
	public static void copyFromResource(OutputStream out, String resourcePath)
			throws IOException {
		InputStream is = null;
		try {
			is = Tool.class.getResourceAsStream(resourcePath);
			if (is == null) {
				throw new IOException("No resource found:" + resourcePath); //$NON-NLS-1$
			}
			int b;
			while ((b = is.read()) != -1) {
				out.write(b);
			}

		} finally {
			if (is != null) {
				is.close();
			}
		}
	}

	/**
	 * fBNg̑݊mFƍ쐬s܂B
	 * @param f ݒtH_̃pX
	 * @return fBNg݂ꍇtrueA쐬łȂꍇfalseB
	 */
	public static boolean makeDirectory(File f) {
		if (!f.mkdirs()) {
			return f.isDirectory();
		}
		return true;
	}

	/**
	 * SWTŒڕ\ł摜t@C̊gqǂԂ܂B
	 * <p>
	 * TIFF͂܂sȂꍇ̂ŏOĂ܂(SWT 3.4)B
	 * 
	 * @param path t@CpX
	 * @return 摜̏ꍇtrue
	 */
	public static boolean isImageFile(String path) {
		if (path == null) {
			return false;
		}
		String lower = path.toLowerCase();
		if (lower.endsWith(".png") || lower.endsWith(".jpg") //$NON-NLS-1$ //$NON-NLS-2$
				|| lower.endsWith(".jpeg") || lower.endsWith(".gif") //$NON-NLS-1$ //$NON-NLS-2$
				|| lower.endsWith(".bmp") || lower.endsWith(".ico")) { //$NON-NLS-1$ //$NON-NLS-2$
			return true;
		}
		return false;
	}

	/**
	 * ACfg܂B
	 * <p>
	 * s̓ACfgx̃JEg̑ΏۊOɂȂ܂B
	 * 
	 * @param str 
	 * @return ACfg
	 */
	public static String unindent(String str) {
		String[] lines = splitLines(str);
		String leading = null;
		for (int i = 0; i < lines.length; i++) {
			if (lines[i].length() == 0) {
				continue;
			}
			switch (lines[i].charAt(0)) {
			case '\r':
			case '\n':
				// s
				continue;
			case ' ':
			case '\t':
				// Cfg
				break;
			default:
				// sƃCfgȊO
				return str;
			}

			if (leading == null) {
				Pattern pat = Pattern.compile("^[\\t\\x20]+"); //$NON-NLS-1$
				Matcher m = pat.matcher(lines[i]);
				if (m.find()) {
					leading = m.group();
				}
			} else {
				while (!lines[i].startsWith(leading)) {
					leading = chop(leading);
				}
			}
		}
		if (leading != null) {
			for (int i = 0; i < lines.length; i++) {
				if (lines[i].length() == 0) {
					continue;
				}
				switch (lines[i].charAt(0)) {
				case '\r':
				case '\n':
					// s
					continue;
				}
				lines[i] = lines[i].substring(leading.length());
			}
			str = ""; //$NON-NLS-1$
			for (int i = 0; i < lines.length - 1; i++) {
				str += lines[i];
			}
			str += lines[lines.length - 1];
		}
		return str;
	}

	/**
	 * 1폜ĕԂ܂B
	 * <p>
	 * nullA󕶎͈̂܂ܕԂ܂B
	 * 
	 * @param str 
	 * @return 1폜
	 */
	public static String chop(String str) {
		if (str == null || str.length() == 0) {
			return str;
		}
		return str.substring(0, str.length() - 1);
	}

	/**
	 * WMFLogical unitMM_HIMETRICA96dpiƉ肵ĊZ܂B
	 * <p>
	 * 1logical unit = 0.01mm (MM_HIMETRIĈƂ)
	 * 
	 * @param px sNZ
	 * @return Logical unit
	 */
	public static int pixelToLogicalUnit(int px) {
		// 1inch = 2.54cm = 2540/0.01mm
		// 96px:1inch=px:result
		return (2540 * px) / 96;
	}

	/**
	 * 96dpiƉ肵TwipɊZ܂B
	 * <p>
	 * 1440 twip = 1 inch
	 * 
	 * @param px sNZ
	 * @return Twip
	 */
	public static int pixelToTwip(int px) {
		return (1440 * px) / 96;
	}

	/**
	 * zSetɕϊ܂B
	 * @param array z
	 * @return Set
	 */
	public static Set newSetFromArray(Object[] array) {
		Set result = new HashSet(array.length);
		for (int i = 0; i < array.length; i++) {
			result.add(array[i]);
		}
		return result;
	}

	/**
	 * ftHgCharset擾܂B
	 * 
	 * @return ftHgCharset
	 */
	public static Charset defaultCharset() {
		if (javaVersion1_5_orHigher) {
			return Charset.defaultCharset();
		}
		return Charset.forName(System.getProperty("file.encoding")); //$NON-NLS-1$
	}

	/**
	 * IOExceptionԂ܂B
	 * @param message bZ[W
	 * @param cause 
	 * @return bvO
	 */
	public static IOException newIOException(String message, Throwable cause) {
		if (javaVersion1_6_orHigher) {
			return new IOException(message, cause);
		}
		return new IOException(message + "\n" + getStackTraceString(cause)); //$NON-NLS-1$
	}

	/**
	 * WindowsexewrapexẽpXԂ܂B
	 * 
	 * @return exẽpX܂null
	 */
	public static File getExewrapExecutable() {
		String exewrapPath = System.getProperty("java.application.path"); //$NON-NLS-1$
		if (exewrapPath != null) {
			String exewrapName = System.getProperty("java.application.name"); //$NON-NLS-1$
			return new File(exewrapPath, exewrapName);
		}
		return null;
	}

	/**
	 * JgfBNg
	 */
	private static String currentDirectory;

	/**
	 * {@link #saveCurrentDir()}ŕۑJgfBNgԂ܂B
	 * 
	 * @return JgfBNg
	 */
	public static String getCurrentDirectory() {
		return currentDirectory;
	}

	/**
	 * NɌĂяoAJgfBNgɕێ܂B
	 */
	public static void saveCurrentDir() {
		currentDirectory = System.getProperty("user.dir"); //$NON-NLS-1$
	}

	/**
	 * w肵NX̃pX擾܂B
	 * @param clazz NX
	 * @return NX݂̑pX(fBNg)
	 */
	public static String getClassLocation(Class clazz) {
		String fqcn = clazz.getName();
		String relativePath = fqcn.replace('.', '/') + ".class"; //$NON-NLS-1$

		URL classUrl = clazz.getClassLoader().getResource(relativePath);
		if (classUrl == null) {
			// exȅꍇ
			return null;
		}

		// URL\̐΃pX
		String absolutePath = classUrl.toExternalForm();

		// x[X̃pX(URL)𓾂B
		// NX̏ꍇ͋NfBNgɂȂĂ
		// jar:file:̏ꍇjar̃[gfBNgɂȂ
		return absolutePath.substring(0,
				absolutePath.length() - relativePath.length());
	}

	/**
	 * Jar̃pX擾܂B
	 * @param classLocation jar̃NXURLBgetClassLocation(Class)̖߂lB
	 * @return pX܂nullB
	 */
	public static File getJarPath(String classLocation) {
		//String classLocation = getClassLocation(clazz);

		// jar̂Ƃ
		if (classLocation.startsWith("jar:") && classLocation.endsWith("!/")) { //$NON-NLS-1$ //$NON-NLS-2$

			// "!/"폜
			classLocation = classLocation.substring(0,
					classLocation.length() - 2);

			if (classLocation.startsWith("jar:file:")) { //$NON-NLS-1$
				/*
				 * jar[Jt@ĈƂ͐擪"jar:"폜A
				 * fileXL[}URL𓾂B
				 * 
				 * URLURIɕϊAFile𓾂B
				 * 
				 * FileefBNg𓾂邱Ƃɂ
				 * jart@C폜B
				 */

				// 擪"jar:"폜
				classLocation = classLocation.substring(4);

				try {
					// URLFileɕϊ
					URI uri = new URI(classLocation);
					return new File(uri);

				} catch (URISyntaxException e) {
					e.printStackTrace();
				}
			}
			// FIXME UNCpX̂ƂAHTTP̂Ƃ
			return null;
		}
		return null;
	}

	/**
	 * vÕfBNg擾܂B
	 * 
	 * @param clazz mainNXȂ
	 * @return vÕfBNg
	 */
	public static File getProgramDirectory(Class clazz) {

		// exȅꍇ
		File exewrapPath = getExewrapExecutable();
		if (exewrapPath != null) {
			return exewrapPath.getParentFile();
		}

		String classLocation = getClassLocation(clazz);
		// jar̂Ƃ
		File jarPath = getJarPath(classLocation);
		if (jarPath != null) {
			return jarPath.getParentFile();
		}

		/*
		 * NXt@C̏ꍇ
		 */
		try {
			URI uri = new URI(classLocation);
			return new File(uri);

		} catch (URISyntaxException e) {
			e.printStackTrace();
		}
		return null;
	}

	/**
	 * t@Cɑ΂MessageDigest߂܂B
	 * 
	 * @param file t@C
	 * @param mds MessageDigest̔z
	 * @throws IOException
	 */
	public static void getDigest(File file, MessageDigest[] mds)
			throws IOException {
		FileInputStream fin = null;
		BufferedInputStream in = null;

		try {
			fin = new FileInputStream(file);
			in = new BufferedInputStream(fin);

			byte[] buf = new byte[1024 * 8];

			int size = 0;
			while ((size = in.read(buf)) != -1) {
				for (int i = 0; i < mds.length; i++) {
					mds[i].update(buf, 0, size);
				}
			}

		} finally {
			if (in != null) {
				in.close();
			} else if (fin != null) {
				fin.close();
			}
		}
	}

	/**
	 * w肵URL̃t@CGETŎ擾Ao̓Xg[ɏ݂܂B
	 * 
	 * @param url 擾URL
	 * @param out o̓Xg[
	 * @return HTTP response code (HttpURLConnection.HTTP_OK Ȃ)
	 * @throws IOException
	 */
	public static int download(URL url, OutputStream out) throws IOException {
		HttpURLConnection conn = null;
		try {
			conn = (HttpURLConnection) url.openConnection();
			conn.setAllowUserInteraction(false);
			conn.setInstanceFollowRedirects(false);
			conn.setRequestMethod("GET"); //$NON-NLS-1$

			conn.connect();

			int res = conn.getResponseCode();
			if (res != HttpURLConnection.HTTP_OK) {
				return res;
			}

			InputStream is = null;
			BufferedInputStream bi = null;

			try {
				is = conn.getInputStream();
				bi = new BufferedInputStream(is);

				byte[] buf = new byte[1024 * 8];

				while (true) {
					int size = Tool.readComplete(bi, buf);
					out.write(buf, 0, size);
					if (size < buf.length) {
						break;
					}
				}

				return HttpURLConnection.HTTP_OK;

			} finally {
				if (bi != null) {
					bi.close();
				} else if (is != null) {
					is.close();
				}
			}

		} finally {
			if (conn != null) {
				conn.disconnect();
			}
		}
	}

	/**
	 * dptĒǉ܂B
	 * łɓdptĂꍇ́Â܂ܒǉ܂B
	 * ϐȂǓꕶ͍l܂B
	 * @param sb ǉ
	 * @param execPath spX
	 */
	public static void quoteExecPath(StringBuffer sb, String execPath) {
		if (execPath == null || execPath.length() == 0) {
			return;
		} else if (execPath.indexOf(' ') == -1) {
			sb.append(execPath);
		} else if (execPath.charAt(0) == '"'
				&& execPath.charAt(execPath.length() - 1) == '"') {
			sb.append(execPath);
		} else {
			sb.append('"');
			sb.append(execPath);
			sb.append('"');
		}
	}

	/**
	 * GXP[vēdpň݂͂܂B
	 * 
	 * @param plainArg 1
	 * @return GXP[vς݂̈
	 */
	public static String escapeArgumentWindows(String plainArg) {
		StringBuffer sb = new StringBuffer(plainArg.length() * 2 + 2);
		sb.append('"');
		for (int i = 0; i < plainArg.length(); i++) {
			char c = plainArg.charAt(i);
			switch (c) {
			case '"':
				sb.append('\\');
				break;
			case '\\':
				if (plainArg.length() == i + 1) {
					//Ō̏ꍇ̓GXP[vsv
				} else if (plainArg.charAt(i + 1) == '"') {
					sb.append("\\"); //$NON-NLS-1$
				}
				break;
			}
			sb.append(c);
		}
		sb.append('"');
		return sb.toString();
	}

	/**
	 * \[Xe|t@CɖߍݕϐuȂRs[܂B
	 * <p>
	 * ߍݕϐ ${key} ̌`ŁAkey \w ̕Wgpł܂B
	 * 
	 * @param resourcePath Rs[̃\[XpX
	 * @param prefix ꎞt@C̐擪
	 * @param postfix ꎞt@C̖
	 * @param context uϐ̒l
	 * @param dir ꎞt@C쐬fBNg
	 * @return e|t@C
	 * @throws IOException
	 */
	public static File copyWithReplace(String resourcePath, String prefix,
			String postfix, Map context, File dir) throws IOException {

		File f = null;

		FileOutputStream out = null;
		OutputStreamWriter osw = null;

		try {
			InputStream in = null;

			f = File.createTempFile(prefix, postfix, dir);
			out = new FileOutputStream(f);
			osw = new OutputStreamWriter(out);

			in = SWTMainWindow.class.getResourceAsStream(resourcePath);
			if (in == null) {
				throw new IOException("No resource found:" + resourcePath); //$NON-NLS-1$
			}

			String content;
			try {
				content = readComplete(in, 1024 * 4, defaultCharset());
			} finally {
				in.close();
			}
			Pattern ptn = Pattern.compile("\\$\\{(\\w+)}"); //$NON-NLS-1$
			String outStr = replaceAll(content, ptn, 1, context);
			osw.write(outStr);

		} finally {
			if (osw != null) {
				osw.close();
			}
		}

		return f;
	}

	/**
	 * w肵͈͂̕Ԃ܂B
	 * @param str 
	 * @param start JnCfbNX
	 * @param end ICfbNX(exclusive)
	 * @return 
	 */
	public static String substring(String str, int start, int end) {
		if (str != null && str.length() > start) {
			if (str.length() >= end) {
				return str.substring(start, end);
			}
			return str.substring(start);
		}
		return ""; //$NON-NLS-1$
	}
}
