package petaclone;

import java.util.Comparator;

/**
 * @author Takayuki Shoji
 */
public class AttachmentPositionComparator implements Comparator {

	/** ̎true */
	private final int direction;

	/**
	 * RXgN^
	 * @param ascent ̎true
	 */
	public AttachmentPositionComparator(boolean ascent) {
		direction = ascent ? 1 : -1;
	}

	public int compare(Object att1, Object att2) {
		int pos1 = ((Attachment) att1).position;
		int pos2 = ((Attachment) att2).position;
		pos1 = pos1 < 0 ? Integer.MAX_VALUE : pos1;
		pos2 = pos2 < 0 ? Integer.MAX_VALUE : pos2;
		return direction * (pos1 - pos2);
	}
}
