package petaclone;

/**
 * ݒ_CAÕRg[𐶐C^[tF[XB
 * ebZW[̐ݒ_CAO𐶐ۂɎgpB
 * @author Takayuki Shoji
 */
public interface ControlCreator {

	/**
	 * `FbN{bNXzu܂B
	 * @param property vpeB[
	 * @param label x
	 * @param defaultValue vpeB̃ftHgl(Rg[̏Ԃł͂܂)
	 */
	void createCheckBox(String property, String label, boolean defaultValue);

	/**
	 * WI{^̃O[vzu܂B<br>
	 * vpeBl擾łȂꍇ0Ԗڂ̗vfftHglɂȂ܂B
	 * @param property vpeB[
	 * @param label O[ṽx
	 * @param values \l
	 * @param propertyValues vpeBɃZbgl
	 * @param defaultValue ftHgl
	 */
	void createRadioButton(String property, String label, String[] values,
			String[] propertyValues, String defaultValue);

	/**
	 * R{{bNX(ǂݍݐp)zu܂B<br>
	 * vpeBl擾łȂꍇ0Ԗڂ̗vfftHglɂȂ܂B
	 * @param property vpeB[
	 * @param label x
	 * @param values Il
	 * @param propertyValues vpeBɃZbgl
	 * @param defaultValue ftHgl
	 * @param compact trueȂ1sŕ\
	 */
	void createComboBox(String property, String label, String[] values,
			String[] propertyValues, String defaultValue, boolean compact);

	/**
	 * eLXg{bNXzu܂B
	 * @param property vpeB[
	 * @param label x
	 * @param defaultText vpeB̃ftHgl
	 * @param compact trueȂ1sŕ\
	 * @param checker ͒l̃`FbJ
	 */
	void createText(String property, String label, String defaultText,
			boolean compact, ControlChecker checker);

	/**
	 * pX[h{bNXzu܂B
	 * @param property vpeB[
	 * @param buttonLabel x
	 * @param dialogTitle pX[hύX_CAÕ^Cg
	 */
	void createPasswordBox(String property, String buttonLabel,
			String dialogTitle);

	/**
	 * Spinnerzu܂B
	 * @param property vpeB[
	 * @param label x
	 * @param defaultValue ftHgl
	 * @param compact truȅꍇARpNg\
	 * @param min ŏl
	 * @param max ől
	 * @param increment 
	 */
	void createSpinner(String property, String label, int defaultValue,
			boolean compact, int min, int max, int increment);

	/**
	 * fBNgIzu܂B
	 * @param property vpeB[
	 * @param label x
	 * @param defaultValue ftHgl
	 * @param initialPath pX
	 * @param editable ҏW\
	 * @param useTextBoxPath pXƂăeLXg{bNX̒lg
	 */
	void createDirectorySelector(String property, String label,
			String defaultValue, String initialPath, boolean editable,
			boolean useTextBoxPath);

	/**
	 * t@CIzu܂B
	 * @param property vpeB
	 * @param label x
	 * @param defaultValue ftHgl
	 * @param initialPath pX
	 * @param filterNames tB^
	 * @param filterExtentions tB^gq
	 * @param editable ҏW\
	 */
	void createFileSelector(String property, String label, String defaultValue,
			String initialPath, String[] filterNames,
			String[] filterExtentions, boolean editable);

	/**
	 * ͕⏕{^teLXg{bNX
	 * 
	 * @param property vpeB
	 * @param label x
	 * @param defaultValue ftHgl
	 * @param menuData |bvAbvj[̃xƑ}eLXg̔z
	 */
	void createAssistedTextBox(String property, String label,
			String defaultValue, String[][] menuData);

	/**
	 * xzu܂B
	 * @param text \eLXg
	 */
	void createLabel(String text);

	/**
	 * Zp[^zu܂Bɐ܂B
	 */
	void createSeparator();

	/**
	 * tHg_CAOJ߂̃{^\܂B
	 * @param propertyPrefix vpeB̃vtBbNX
	 * @param label x
	 */
	void createFontDialogButton(String propertyPrefix, String label);
}
