package petaclone;

import java.io.IOException;
import java.io.Writer;

import jp.takayuki.tools.Tool;

/**
 * ML^
 * @author Takayuki Shoji
 */
public class Destination {
	/** gpbZW[ID */
	private String launchId;

	/** M̃OC */
	private String loginName;

	/** M̃Rs[^ */
	private String computerName;

	/** [U[(jbNl[) */
	private String userName;

	/** IPAhX */
	private String ipAddress;

	/** |[gԍ */
	private int port;

	/** M */
	private boolean result;

	/**
	 * pRXgN^
	 */
	public Destination() {
		//
	}

	/**
	 * Mʂ𐶐邽߂̃RXgN^
	 * @param launchId MɎgpbZW[̋NIDB
	 * @param loginName OC
	 * @param computerName Rs[^
	 * @param userName [U
	 * @param ipAddress IPAhX
	 * @param port |[gԍ
	 * @param result MʁBtrue͐B
	 */
	public Destination(String launchId, String loginName, String computerName,
			String userName, String ipAddress, int port, boolean result) {

		this.launchId = launchId;
		this.result = result;
		this.loginName = loginName;
		this.computerName = computerName;
		this.userName = userName;
		this.ipAddress = ipAddress;
		this.port = port;
	}

	/**
	 * WriterXMLo͂܂B
	 * @param w o͐
	 * @throws IOException 
	 */
	public void writeXml(Writer w) throws IOException {
		Tool.writeStartElement(w, "destination"); //$NON-NLS-1$
		Tool.writeElement(w, "destlaunchid", launchId); //$NON-NLS-1$
		Tool.writeElement(w, "result", result); //$NON-NLS-1$
		Tool.writeElement(w, "destloginname", loginName); //$NON-NLS-1$
		Tool.writeElement(w, "destcomputername", computerName); //$NON-NLS-1$
		Tool.writeElement(w, "destusername", userName); //$NON-NLS-1$
		Tool.writeElement(w, "ipaddress", ipAddress); //$NON-NLS-1$
		Tool.writeElement(w, "port", Integer.toString(port)); //$NON-NLS-1$
		Tool.writeEndElement(w, "destination"); //$NON-NLS-1$
	}

	/**
	 * @return M̃Rs[^
	 */
	public String getComputerName() {
		return computerName;
	}

	/**
	 * @return MɎgpbZW[̋NID
	 */
	public String getLaunchId() {
		return launchId;
	}

	/**
	 * @return M̃OC
	 */
	public String getLoginName() {
		return loginName;
	}

	/**
	 * @return M
	 */
	public boolean getResult() {
		return result;
	}

	/**
	 * @return M̃[U
	 */
	public String getUserName() {
		return userName;
	}

	/**
	 * @param computerName M̃Rs[^
	 */
	public void setComputerName(String computerName) {
		this.computerName = computerName;
	}

	/**
	 * @param launchId MɎgpbZW[̋NID
	 */
	public void setLaunchId(String launchId) {
		this.launchId = launchId;
	}

	/**
	 * @param loginName M̃OC
	 */
	public void setLoginName(String loginName) {
		this.loginName = loginName;
	}

	/**
	 * @param result M
	 */
	public void setResult(boolean result) {
		this.result = result;
	}

	/**
	 * @param userName M̃[U[
	 */
	public void setUserName(String userName) {
		this.userName = userName;
	}

	/**
	 * [U[ʎqԂ܂B
	 * @return Z[U[ʎq(Rs[^)
	 */
	public String getIdentifier() {
		//return computerName.toUpperCase();
		return ipAddress;
	}

	/**
	 * IPAhXԂ܂B
	 * @return IPAhX
	 */
	public String getIpAddress() {
		return ipAddress;
	}

	/**
	 * IPAhXݒ肵܂B
	 * @param ipAddress IPAhX
	 */
	public void setIpAddress(String ipAddress) {
		this.ipAddress = ipAddress;
	}

	/**
	 * |[gԍ擾܂B
	 * @return |[gԍ
	 */
	public int getPort() {
		return port;
	}

	/**
	 * |[gԍݒ肵܂B
	 * @param port |[gtԍ
	 */
	public void setPort(int port) {
		this.port = port;
	}

	/**
	 * CX^X̏Ԃ𕶎񉻂܂B
	 */
	public String toString() {
		StringBuffer sb = new StringBuffer("Destination{"); //$NON-NLS-1$
		sb.append("launchId=").append(launchId); //$NON-NLS-1$
		sb.append(", loginName=").append(loginName); //$NON-NLS-1$
		sb.append(", computerName=").append(computerName); //$NON-NLS-1$
		sb.append(", userName=").append(userName); //$NON-NLS-1$
		sb.append(", ipAddress=").append(ipAddress); //$NON-NLS-1$
		sb.append(", port=").append(port); //$NON-NLS-1$
		sb.append(", result=").append(result); //$NON-NLS-1$
		sb.append('}');
		return sb.toString();
	}
}
