package petaclone;

import jp.takayuki.tools.MessageMap;

/**
 * lpControlChecker
 * @author Takayuki Shoji
 */
public class NumberControlChecker implements ControlChecker {

	/**
	 * bZ[W\[X
	 */
	private static final MessageMap mm = MessageMap.getMessageMap();

	/** ŏl */
	private int min;

	/** ől */
	private int max;

	/**
	 * RXgN^
	 * @param min ŏl
	 * @param max ől
	 */
	public NumberControlChecker(int min, int max) {
		this.min = min;
		this.max = max;
	}

	/**
	 * ͂ł镶ǂ`FbN܂B
	 */
	public boolean checkType(char character) {
		if ('0' <= character && character <= '9') {
			return true;
		}
		return false;
	}

	/**
	 * ԍ͈͓ǂ`FbN܂B
	 */
	public boolean checkValue(String value) {
		try {
			int i = Integer.parseInt(value);
			if (min <= i && i <= max) {
				return true;
			}
		} catch (NumberFormatException e) {
			//
		}
		return false;
	}

	/**
	 * trueԂ܂B
	 */
	public boolean checkValues(String[] values) {
		return true;
	}

	/**
	 * `FbNpxԂ܂B
	 */
	public int getFrequency() {
		return CHECK_EVERY;
	}

	/**
	 * RԂ܂B
	 */
	public String getReason() {
		return mm.get("NumberControlChecker.reason",//$NON-NLS-1$
				new Object[] { new Integer(min), new Integer(max) });
	}
}
