package petaclone;

import java.io.UnsupportedEncodingException;

import jp.takayuki.tools.MessageMap;

/**
 * bytePʂŃ`FbN܂B
 * @author Takayuki Shoji
 */
public class StringControlChecker implements ControlChecker {

	/**
	 * bZ[W\[X
	 */
	private static final MessageMap mm = MessageMap.getMessageMap();

	/**
	 * oCgPʂ̍ő咷
	 */
	private int limit;

	/**
	 * GR[fBO
	 */
	private String encoding;

	/**
	 * RXgN^
	 * @param encoding GR[fBO
	 * @param limit oCgPʂł̍ő咷
	 */
	public StringControlChecker(String encoding, int limit) {
		this.encoding = encoding;
		this.limit = limit;
	}

	public boolean checkType(char character) {
		return true;
	}

	public boolean checkValue(String value) {
		// `FbN
		try {
			if (value.getBytes(encoding).length > limit) {
				return false;
			}
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
			//return false;
		}
		return true;
	}

	public boolean checkValues(String[] values) {
		return true;
	}

	public int getFrequency() {
		return CHECK_EVERY;
	}

	public String getReason() {
		return mm.get("StringControlChecker.reason", //$NON-NLS-1$
				new Object[] { new Integer(limit) });
	}
}
