package petaclone.logic;

import petaclone.AppPreferences;
import petaclone.EventListener;
import petaclone.MessengerFacade;
import petaclone.RuntimeProperties;

/**
 * s݃[hICxg̏
 * @author Takayuki Shoji
 */
public class EndAutoAbsence implements EventListener {

	/**
	 * ݒ
	 */
	private AppPreferences pref;

	/**
	 * MessengerFacade
	 */
	private MessengerFacade facade;

	/**
	 * RXgN^
	 * @param pref ݒ
	 * @param facade MessengerFacade
	 */
	public EndAutoAbsence(AppPreferences pref, MessengerFacade facade) {
		this.pref = pref;
		this.facade = facade;
	}

	/**
	 * s݃[hICxg̏
	 */
	public void listen(String eventName, Object event) {
		RuntimeProperties rp = pref.getRuntime();
		if (rp.getPresence() != RuntimeProperties.PRESENCE_AUTO_ABSENCE) {
			return;
		}

		rp.setPresence(RuntimeProperties.PRESENCE_NORMAL);
		facade.sendAbsenceMode(false);
	}

}
